<?php
if ( ! defined('ABSPATH') ) die();
// Admin bootstaps
require_once(ABSPATH.'wp-admin'.DIRECTORY_SEPARATOR.'admin.php');
require_once(ABSPATH.'wp-includes'.DIRECTORY_SEPARATOR.'pluggable.php');

// Do this here just to be on the safe side
if(!is_user_logged_in())
{
	header("Location:".get_bloginfo('home').'/wp-login.php');
	exit();
}
require_once(ARCHITECT_ADMIN_DIR.'wp-admin'.DIRECTORY_SEPARATOR.'functions.php');

$post = get_post_to_edit($_REQUEST['post']);

// Load categories
$descendants_and_self = 0;
$selected_cats = false;
$popular_cats = false;
$post_id = $post->ID;
$post_ID = $post->ID;

$descendants_and_self = (int) $descendants_and_self;
$args = array();

if ( is_array( $selected_cats ) )
	$args['selected_cats'] = $selected_cats;
elseif ( $post_id )
	$args['selected_cats'] = wp_get_post_categories($post_ID);
else
	$args['selected_cats'] = array();

if ( is_array( $popular_cats ) )
	$args['popular_cats'] = $popular_cats;
else
	$args['popular_cats'] = get_terms( 'category', array( 'fields' => 'ids', 'orderby' => 'count', 'order' => 'DESC', 'number' => 10, 'hierarchical' => false ) );

if ( $descendants_and_self ) {
	$categories = get_categories( "child_of=$descendants_and_self&hierarchical=0&hide_empty=0" );
	$self = get_category( $descendants_and_self );
	array_unshift( $categories, $self );
} else {
	$categories = get_categories('get=all');
}

// Post process $categories rather than adding an exclude to the get_terms() query to keep the query the same across all posts (for any query cache)
$checked_categories = array();
$keys = array_keys( $categories );

foreach( $keys as $k ) {
	if ( in_array( $categories[$k]->term_id, $args['selected_cats'] ) ) {
		$checked_categories[] = $categories[$k];
		unset( $categories[$k] );
	}
}

// Save data
if(isset($_POST) && !empty($_POST))
{
	if(isset($_FILES) && !empty($_FILES) && $_FILES['async-upload']['name'] != '')
	{
		$id = media_handle_upload('async-upload', $_REQUEST['post_id']);
		
		$file_size = (isset($_REQUEST['file_upload_size'])) ? $_REQUEST['file_upload_size']: '';
		$file = wp_get_attachment_image_src($id, $file_size);
		
		if($_POST['file_upload_location'] == 'top')
		{
			$_POST['content'] = '<img src="'.$file[0].'" />
'.$_POST['content'];
		} else if($_POST['file_upload_location'] == 'bottom')
		{
			$_POST['content'] .= '
<img src="'.$file[0].'" />';
		}
	}
	
	// Set post category
	$_POST['post_category'] = array();
	foreach(array_merge($checked_categories, $categories) as $cat)
	{
		if(isset($_POST['post_category_'.$cat->cat_ID]) AND $_POST['post_category_'.$cat->cat_ID] == true)
		{
			$_POST['post_category'][] = $cat->cat_ID;
		}
	}
	
	// Setup correct tags array for saving
	$_POST['tags_input'] = array();
	if(isset($_POST['tags_input_input']) AND $_POST['tags_input_input'] != '')
	{
		foreach(explode(',', $_POST['tags_input_input']) as $tag)
		{
			$_POST['tags_input'][] = trim($tag);
		}
	}
	
	// Publish Date
	if(is_numeric($_POST['post_date_Y']) AND is_numeric($_POST['post_date_M']) AND is_numeric($_POST['post_date_D']) AND is_numeric($_POST['post_date_H']) AND is_numeric($_POST['post_date_Mi']))
	{
		$_POST['post_date'] = sprintf("%04s", $_POST['post_date_Y']).'-'.
			sprintf("%02s", $_POST['post_date_M']).'-'.
			sprintf("%02s", $_POST['post_date_D']).' '.
			sprintf("%02s", $_POST['post_date_H']).':'.
			sprintf("%02s", $_POST['post_date_Mi']).':00';
		$_POST['post_date_gmt'] = get_gmt_from_date($_POST['post_date']);
	}
	
	if(edit_post($_POST))
	{
		header("Location:".admin_url().$_POST['_wp_http_referer'].'?message=1');
		exit();
	}
}

$waplString = '';
$pageTitle = 'Edit Post';
$pageId = 'editPost';
$thisMainMenu = 'Posts';

// Header
$waplString .= require_once(ARCHITECT_ADMIN_DIR.'wp-admin'.DIRECTORY_SEPARATOR.'header.php');

// Navigation
$waplString .= require_once(ARCHITECT_ADMIN_DIR.'wp-admin'.DIRECTORY_SEPARATOR.'menu'.DIRECTORY_SEPARATOR.'main.php');
$waplString .= require_once(ARCHITECT_ADMIN_DIR.'wp-admin'.DIRECTORY_SEPARATOR.'menu'.DIRECTORY_SEPARATOR.'edit.php');
$waplString .= '<wordsChunk id="'.$pageId.'"><quick_text>[p]edit post[/p][h2]'.$pageH1.'[/h2]</quick_text></wordsChunk>';

// Set up some variables we need for the form
global $user_ID;

$waplString .= '
<form>
	<action>post.php</action>
	<formItem item_type="hidden"><name>post_author</name><value>'.$post->post_author.'</value></formItem>
	<formItem item_type="hidden"><name>user_ID</name><value>'.(int) $user_ID.'</value></formItem>
	<formItem item_type="hidden"><name>post_ID</name><value>'.$post->ID.'</value></formItem>
	<formItem item_type="hidden"><name>post</name><value>'.$post->ID.'</value></formItem>
	<formItem item_type="hidden"><name>ID</name><value>'.$post->ID.'</value></formItem>
	<formItem item_type="hidden"><name>post_type</name><value>post</value></formItem>
	<formItem item_type="hidden"><name>comment_status</name><value>'.$post->comment_status.'</value></formItem>
	<formItem item_type="hidden"><name>ping_status</name><value>'.$post->ping_status.'</value></formItem>
	<formItem item_type="hidden"><name>action</name><value>save</value></formItem>
	<formItem item_type="hidden"><name>_wp_http_referer</name><value>edit.php</value></formItem>
	<formItem item_type="text"><label>Title</label><name>post_title</name><value>'.$post->post_title.'</value></formItem>';

$trans = '';
$trans = (is_array($trans)) ? $trans : get_html_translation_table(HTML_ENTITIES, ENT_QUOTES);
foreach ($trans as $k=>$v)
	$trans[$k]= "&#".ord($k).";";

$waplString .= '
	<formItem item_type="textarea"><label>Content</label><name>content</name><value>'.htmlentities(strtr($post->post_content, $trans)).'</value></formItem>';

$waplString .= '
	<formItem item_type="textarea"><label>Excerpt</label><name>excerpt</name><value>'.$post->post_excerpt.'</value></formItem>';
$current_user = wp_get_current_user();
$user_id = $current_user->ID;
$can_upload = get_option('architect_admin_file_upload_'.$user_id);

if($can_upload === '0')
{
	$waplString .= '<formItem item_type="title"><name>async-upload-off</name><label>File uploading is disabled for this user. To re-enable it, switch it back on in the [url=profile.php]Profile[/url] page</label></formItem>';
} else
{
	$waplString .= '<formItem item_type="file"><label>File Upload</label><name>async-upload</name></formItem>';
	$waplString .= '<formItem item_type="select">
		<label>Image Location</label><name>file_upload_location</name>
		<possibility>
			<label>Top</label>
			<value>top</value>
		</possibility>
		<possibility>
			<label>Bottom</label>
			<value>bottom</value>
		</possibility>
	</formItem>';
	
	if(function_exists('gd_info'))
	{
		$waplString .= '
	<formItem item_type="select">
		<label>Image Size</label><name>file_upload_size</name>
		<value>full</value>
		<possibility>
			<label>Thumbnail</label>
			<value>thumbnail</value>
		</possibility>
		<possibility>
			<label>Medium</label>
			<value>medium</value>
		</possibility>
		<possibility>
			<label>Large</label>
			<value>large</value>
		</possibility>
		<possibility>
			<label>Full size</label>
			<value>full</value>
		</possibility>
	</formItem>';
	} else
	{
		$waplString .= '<formItem item_type="hidden"><name>file_upload_size</name><value>full</value></formItem>';
	}
}

$waplString .= '
	<formItem item_type="select"><name>post_status</name>
	<value>'.$post->post_status.'</value>
	<label>Post Status</label>
		<possibility>
			<label>Draft</label>
			<value>draft</value>
		</possibility>
		<possibility>
			<label>Pending Review</label>
			<value>pending</value>
		</possibility>
		<possibility>
			<label>Published</label>
			<value>publish</value>
		</possibility>
		<possibility>
			<label>Future</label>
			<value>future</value>
		</possibility>
	</formItem>';

// Publish Date
if($post->post_date > date("Y-m-d H:i:s"))
{
	$label = 'Scheduled Publish Date';
} else
{
	$label = 'Publish Date';
}

// Publish date
$waplString .= '</form></layout><layout start_stack="div"><form>';
$waplString .= '<formItem item_type="title"><name></name><label>'.$label.'</label></formItem>';
$waplString .= '<formItem item_type="select" class="post_date"><name>post_date_M</name>
	<label></label>
	<value>'.date("m", strtotime($post->post_date)).'</value>
	<possibility><label>Jan</label><value>01</value></possibility>
	<possibility><label>Feb</label><value>02</value></possibility>
	<possibility><label>Mar</label><value>03</value></possibility>
	<possibility><label>Apr</label><value>04</value></possibility>
	<possibility><label>May</label><value>05</value></possibility>
	<possibility><label>Jun</label><value>06</value></possibility>
	<possibility><label>Jul</label><value>07</value></possibility>
	<possibility><label>Aug</label><value>08</value></possibility>
	<possibility><label>Sep</label><value>09</value></possibility>
	<possibility><label>Oct</label><value>10</value></possibility>
	<possibility><label>Nov</label><value>11</value></possibility>
	<possibility><label>Dec</label><value>12</value></possibility>
	
</formItem>';
$waplString .= '<formItem item_type="text" class="post_date"><label></label><name>post_date_D</name><value>'.date("d", strtotime($post->post_date)).'</value><input_mask>*N</input_mask></formItem>';
$waplString .= '<formItem item_type="text" class="post_date"><label>,</label><name>post_date_Y</name><value>'.date("Y", strtotime($post->post_date)).'</value><input_mask>*N</input_mask></formItem>';
$waplString .= '<formItem item_type="text" class="post_date"><label>@</label><name>post_date_H</name><value>'.date("H", strtotime($post->post_date)).'</value><input_mask>*N</input_mask></formItem>';
$waplString .= '<formItem item_type="text" class="post_date"><label>:</label><name>post_date_Mi</name><value>'.date("i", strtotime($post->post_date)).'</value><input_mask>*N</input_mask></formItem>';

$waplString .= '</form></layout><layout start_stack="table"><form>';

// Category stuff here
$waplString .= '<formItem class="dashboardSection" item_type="title"><label>Categories</label><name>categories</name></formItem>';

foreach($checked_categories as $val)
{
	$waplString .= '<formItem class="postCheckbox" item_type="checkbox"><label>'.$val->name.'</label><name>post_category_'.$val->cat_ID.'</name><value>1</value></formItem>';
}
foreach($categories as $val)
{
	$waplString .= '<formItem class="postCheckbox" item_type="checkbox"><label>'.$val->name.'</label><name>post_category_'.$val->cat_ID.'</name><value>0</value></formItem>';
}

// Edit Tags
$waplString .= '<formItem class="dashboardSection" item_type="title"><label>Tags</label><name>tags</name></formItem>';
$waplString .= '<formItem item_type="text"><name>tags_input_input</name><label>Edit tags</label><value>'.get_terms_to_edit( $post->ID).'</value></formItem>';
$waplString .= '<formItem class="formItemComment" item_type="title"><label>Separate tags with commas</label></formItem>';

$waplString .= '<formItem item_type="submit"><label>Save</label><name>edit_post_save</name></formItem></form>';

// Footer
$waplString .= require_once(ARCHITECT_ADMIN_DIR.'wp-admin'.DIRECTORY_SEPARATOR.'footer.php');

// Convert WAPL into markup
process_admin_wapl($waplString);
?>